﻿Imports Inventor 

Public Class Form1

Dim oApp As Inventor.Application

    Private Sub Form1_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
            
        oApp = System.Runtime.InteropServices.Marshal.GetActiveObject("Inventor.Application") 

    End Sub

    Private Sub Button1_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Button1.Click

        '  体 - 面 - 边 - 点

        Dim oDoc As PartDocument
        oDoc = oApp.ActiveDocument

        Dim oDocDef As PartComponentDefinition 
        oDocDef = oDoc.ComponentDefinition 

        ' 考察第一个surfacebody
        Dim oSBody As SurfaceBody 
        oSBody = oDocDef.SurfaceBodies(1)

        ' faceshell，face，edgeloop，edge序号
         Dim oFaceShellIndex As Integer 
         Dim oFaceIndex As Integer 
         Dim oEdgeLoopIndex As Integer 
         Dim oEdgeIndex As Integer 

        Dim oStrShow As String 
        oStrShow = ""

        oFaceShellIndex = 1         
        For Each oFshell As FaceShell In oSBody.FaceShells
                       
           oStrShow &= "第" & oFaceShellIndex & " 个Face Shell "  & vbCr 

            oFaceIndex = 1
            For Each oFace As Face In oFshell.Faces 

                 oStrShow &= "  第" & oFaceIndex & " 个Face"  & vbCr 
                 oStrShow &= "  Face 类型" & oFace.SurfaceType.ToString() & vbCr 
                
                 oEdgeLoopIndex = 1
                  For Each oEdgeLoop As EdgeLoop In oFace.EdgeLoops 
                     oStrShow &=  "      第" & oEdgeLoopIndex & " 个EdgeLoop"  & vbCr 
                      oEdgeIndex = 1
                      For Each oEdge As Edge In oEdgeLoop.Edges 
                          oStrShow &=  "          第" & oEdgeIndex & " 个Edge"  & vbCr 
                            oStrShow &= "        Edge 类型" & oEdge.GeometryType.ToString()  & vbCr 
                          oEdgeIndex += 1
                      Next
                     oEdgeLoopIndex += 1
                  Next

                 oFaceIndex +=1

            Next
            oFaceShellIndex += 1
        Next   

        MessageBox.Show(oStrShow)
    End Sub

    Private Sub Button2_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Button2.Click
           
           Dim oDoc As PartDocument
           oDoc = oApp.ActiveDocument
           
            ' 先选择一个面
           Dim oFace As Face
        oFace = oDoc.SelectSet(1)

        Dim oStrShow As String
        oStrShow = ""

        '输出面的信息
        oStrShow &= "  Face 类型" & oFace.SurfaceType.ToString() & vbCr

        '输出边的信息
           For Each oEdge As Edge In oFace.Edges
            oStrShow &= "        Edge 类型" & oEdge.GeometryType.ToString() & vbCr
                Dim oPt(2) As Double 
                oEdge.StartVertex.GetPoint(oPt)
            oStrShow &= "        起点：[" & oPt(0) & "," & oPt(1) & "," & oPt(2) & "]" & vbCr
                 oEdge.StopVertex.GetPoint(oPt)
            oStrShow &= "        终点：[" & oPt(0) & "," & oPt(1) & "," & oPt(2) & "]" & vbCr
           Next
        MessageBox.Show(oStrShow)
    End Sub

    Private Sub Button3_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Button3.Click

        '给定矢量，通过射线法获取相交的拓扑实体

        '打开某零件文档，确保已经有一个surfacebody
        Dim oPartDoc As PartDocument
        oPartDoc = oApp.ActiveDocument

        '获取第一个surfacebody
        Dim oBody As SurfaceBody
        oBody = oPartDoc.ComponentDefinition.SurfaceBodies.Item(1)

        '获取TransientGeometry
        Dim oTg As TransientGeometry
        oTg = oApp.TransientGeometry

        ' 得到的实体
        Dim oFoundEnts As ObjectsEnumerator = Nothing
        '得到的相交点
        Dim oLocPoints As ObjectsEnumerator = Nothing

        ' 射线法查找
        Call oBody.FindUsingRay(oTg.CreatePoint(-5, 0, 0), _
                                oTg.CreateUnitVector(1, 0, 0), 0.00001, _
                                oFoundEnts, oLocPoints, True)

        '检查得到的结果集合
        If oFoundEnts.Count > 0 Then
            MsgBox("Found " & oFoundEnts.Count & " Entities")
        Else
            MsgBox("No entity along the specified ray.")
        End If
    End Sub

    Private Sub Button4_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Button4.Click

        '打开某零件文档，确保已经有一个surfacebody
        '并且存在spline边

        Dim oPartDoc As PartDocument
        oPartDoc = oApp.ActiveDocument

        Dim oPartDef As ComponentDefinition
        oPartDef = oPartDoc.ComponentDefinition

        Dim oTG As TransientGeometry
        oTG = oApp.TransientGeometry

        '预先选取好spline边
        Dim oSPlineEdge As Edge
        oSPlineEdge = oPartDoc.SelectSet(1)

        '获取求解器
        Dim oEV As CurveEvaluator
        oEV = oSPlineEdge.Evaluator

        ' get extents of the params
        Dim oMinP As Double
        Dim oMaxP As Double

        '求参数范围
        Call oEV.GetParamExtents(oMinP, oMaxP)


        '设置需要离散的点个数
        Dim oNumOfPt As Integer
        oNumOfPt = 100

        '需要用来绘制client graphics的点集合
        Dim oPointCoords(0 To 3 * (oNumOfPt + 1)) As Double
 
      
        '通过求解器按每个参数求对应的点
        Dim i As Integer
        For i = 0 To oNumOfPt

            Dim params(0) As Double
            params(0) = oMinP + i * (oMaxP - oMinP) / oNumOfPt

            ' get the point at the param
            Dim points(2) As Double
            Call oEV.GetPointAtParam(params, points)

            '保存点用于绘制client graphics
            oPointCoords(i * 3) = points(0)
            oPointCoords(i * 3 + 1) = points(1)
            oPointCoords(i * 3 + 2) = points(2)
        Next


        ' 绘制client graphics
        Call DrawCustomLineStrip(oPointCoords)


    End Sub

    Private Sub Button5_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Button5.Click

        ' 确保某零件文档打开，并且有两个surfacebody

        Dim oDoc As PartDocument
        oDoc = oApp.ActiveDocument

        Dim oDocDef As PartComponentDefinition 
        oDocDef = oDoc.ComponentDefinition 

        Dim oTB As TransientBRep 
        oTB = oApp.TransientBRep 

        Dim oTG As TransientGeometry 
        oTG = oApp.TransientGeometry 

        Dim oSBody1 As SurfaceBody 
        oSBody1 = oDocDef.SurfaceBodies(1)

        Dim oSBody2 As SurfaceBody 
        oSBody2 = oDocDef.SurfaceBodies(2)


        '演示1：  拷贝body1，创建TransientBRep，偏移一定位置
        Dim oCopyBody As SurfaceBody
        oCopyBody = oTB.Copy(oSBody1)
         
        '定义偏移矢量
        Dim oVector As  Vector 
        oVector = oTG.CreateVector(10,10,0)

        ' 定义偏移矩阵
        Dim oMatrix As Matrix
        oMatrix = oTG.CreateMatrix 
        oMatrix.SetTranslation(oVector)

        '偏移实体
        oTB.Transform(oCopyBody,oMatrix)

        '将此拷贝实体添加为非参数化特征
        oDocDef.Features.NonParametricBaseFeatures.Add(oCopyBody)


        '演示2： 拷贝body1 和 body2，创建TransientBRep
        ‘ 求其布尔结果，添加为非参数化特征
         Dim oCopyBody1 As SurfaceBody
        oCopyBody1 = oTB.Copy(oSBody1)
         Dim oCopyBody2 As SurfaceBody
        oCopyBody2 = oTB.Copy(oSBody2)

        ' 做布尔运算，注意，结果实体由oCopyBody1保存
        oTB.DoBoolean(oCopyBody1,oCopyBody2,BooleanTypeEnum.kBooleanTypeIntersect)

          '定义偏移矢量
        Dim oVector1 As  Vector 
        oVector1 = oTG.CreateVector(20,20,0)

        oMatrix.SetTranslation(oVector1)

        '偏移实体
        oTB.Transform(oCopyBody1,oMatrix)

         '将此拷贝实体添加为非参数化特征
        oDocDef.Features.NonParametricBaseFeatures.Add(oCopyBody1)




    End Sub

    
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click

        '' 确保某零件文档打开，并且有surfacebody
        Dim oDoc As PartDocument
        oDoc = oApp.ActiveDocument

        Dim oDef As PartComponentDefinition
        oDef = oDoc.ComponentDefinition

        '选取任意边
        Dim pEdge As Edge
        pEdge = oDoc.SelectSet(1)

        '获取求解器
        Dim oCEVal As CurveEvaluator
        oCEVal = pEdge.Evaluator

        '得到参数范围
        Dim minP As Double
        Dim maxP As Double
        oCEVal.GetParamExtents(minP, maxP)

        '设置需要考察的参数个数
        Dim lCount As Integer
        lCount = 10

        Dim inc As Double
        inc = (maxP - minP) / lCount

        Dim i As Integer
        Dim oUParam(0 To lCount - 1) As Double

        '求取每个参数
        For i = 0 To lCount - 1
            oUParam(i) = minP + i * inc
        Next

        '求取每个参数对应的点
        Dim oP(0 To (lCount - 1) * 3) As Double
        oCEVal.GetPointAtParam(oUParam, oP)

        '求取每个点所在的切线方向
        Dim oTan(0 To (lCount - 1) * 3) As Double
        oCEVal.GetFirstDerivatives(oUParam, oTan)

        '绘制切线
        DrawTangentCurve(lCount, oP, oTan)


    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click

        Dim oDoc As Document
        oDoc = oApp.ActiveDocument

        ' 获取当前文档定义
        Dim oCompDef As ComponentDefinition
        oCompDef = oDoc.ComponentDefinition

        Dim oSBody1 As SurfaceBody
        oSBody1 = oCompDef.SurfaceBodies(1)

        '获取Nurbs等价定义
        Dim oNurbsBody As SurfaceBody
        oNurbsBody = oSBody1.AlternateBody(SurfaceGeometryFormEnum.SurfaceGeometryForm_NURBS)

        '考察Nurbs拓扑结构
        Dim oFaceShellIndex As Integer
        Dim oFaceIndex As Integer
        Dim oEdgeLoopIndex As Integer
        Dim oEdgeIndex As Integer

        Dim oStrShow As String
        oStrShow = ""

        oFaceShellIndex = 1
        For Each oFshell As FaceShell In oNurbsBody.FaceShells

            oStrShow &= "第" & oFaceShellIndex & " 个Face Shell " & vbCr


            oFaceIndex = 1
            For Each oFace As Face In oFshell.Faces

                oStrShow &= "  第" & oFaceIndex & " 个Face" & vbCr
                oStrShow &= "  Face 类型" & oFace.SurfaceType.ToString() & vbCr

                oEdgeLoopIndex = 1
                For Each oEdgeLoop As EdgeLoop In oFace.EdgeLoops
                    oStrShow &= "      第" & oEdgeLoopIndex & " 个EdgeLoop" & vbCr
                    oEdgeIndex = 1
                    For Each oEdge As Edge In oEdgeLoop.Edges
                        oStrShow &= "          第" & oEdgeIndex & " 个Edge" & vbCr
                        oStrShow &= "        Edge 类型" & oEdge.GeometryType.ToString() & vbCr
                        oEdgeIndex += 1
                    Next
                    oEdgeLoopIndex += 1
                Next

                oFaceIndex += 1

            Next
            oFaceShellIndex += 1
        Next

        MessageBox.Show(oStrShow)

    End Sub

    ' 辅助函数： 绘制Client Graphics Line Strip

    Public Sub DrawCustomLineStrip(oPointCoords() As Double)

        Dim oDoc As Document
        oDoc = oApp.ActiveDocument

        ' 获取当前文档定义
        Dim oCompDef As ComponentDefinition
         oCompDef = oDoc.ComponentDefinition
    
        ' 查看是否已经有名为SampleGraphicsID的client graphics，若有则删除
     
        Dim oGraphicsData As GraphicsDataSets

        Try
            oGraphicsData = oDoc.GraphicsDataSetsCollection.Item("SampleGraphicsID")
            oGraphicsData.Delete()
            oCompDef.ClientGraphicsCollection.Item("SampleGraphicsID").Delete()
            oApp.ActiveView.Update()
        Catch ex As Exception


        End Try


        '新建client graphics

        ' 获取TransientGeometry
        Dim oTransGeom As TransientGeometry
        oTransGeom = oApp.TransientGeometry

        ' 新建client graphics
        Dim oDataSets As GraphicsDataSets
        oDataSets = oDoc.GraphicsDataSetsCollection.Add("SampleGraphicsID")

        ' Create a coordinate set.
        Dim oCoordSet As GraphicsCoordinateSet
        oCoordSet = oDataSets.CreateCoordinateSet(1)

        ' Create an array that contains coordinates that define a set
        ' of outwardly spiraling points.

        ' Assign the points into the coordinate set.
        Call oCoordSet.PutCoordinates(oPointCoords)

        ' Create the ClientGraphics object.
        Dim oClientGraphics As ClientGraphics
        oClientGraphics = oCompDef.ClientGraphicsCollection.Add("SampleGraphicsID")

        ' Create another graphics node for a line strip.
        Dim oLineStripNode As GraphicsNode
        oLineStripNode = oClientGraphics.AddNode(2)

        ' Create a LineStripGraphics object within the new node.
        Dim oLineStrip As LineStripGraphics
        oLineStrip = oLineStripNode.AddLineStripGraphics

        ' Assign the same coordinate set to the line strip.
        oLineStrip.CoordinateSet = oCoordSet

        ' Create a color set to use in defining a explicit color to the line strip.
        Dim oColorSet As GraphicsColorSet
        oColorSet = oDataSets.CreateColorSet(1)

        ' Add a single color to the set that is red.
        Call oColorSet.Add(1, 255, 0, 0)

        ' Assign the color set to the line strip.
        oLineStrip.ColorSet = oColorSet

        ' we move the client lines so that it is not overlapped with the orignal spline
        Dim oMatrix As Matrix
        oMatrix = oLineStripNode.Transformation
        Call oMatrix.SetTranslation(oTransGeom.CreateVector(0, 2, 0))
        oLineStripNode.Transformation = oMatrix


        ' Update the view to see the resulting spiral.
        oApp.ActiveView.Update()


    End Sub


    '辅助函数： 绘制切线

    Private Sub DrawTangentCurve(ByVal lCount As Integer, ByVal oP() As Double, ByVal oTan() As Double)


        Dim oDoc As Document
        oDoc = oApp.ActiveDocument

        ' 获取当前文档定义
        Dim oCompDef As ComponentDefinition
        oCompDef = oDoc.ComponentDefinition

        ' 查看是否已经有名为SampleGraphicsID的client graphics，若有则删除

        Dim oGraphicsData As GraphicsDataSets

        Try
            oGraphicsData = oDoc.GraphicsDataSetsCollection.Item("Tangent")
            oGraphicsData.Delete()
            oCompDef.ClientGraphicsCollection.Item("Tangent").Delete()
            oApp.ActiveView.Update()
        Catch ex As Exception


        End Try

        oGraphicsData = oDoc.GraphicsDataSetsCollection.Add("Tangent")

        Dim oClientGraphics As ClientGraphics
        oClientGraphics = oCompDef.ClientGraphicsCollection.Add("Tangent")

        Dim adCoords(0 To lCount * 3 * 2) As Double
        Dim j As Integer
        Dim k As Integer

        For i = 0 To lCount - 1

            j = i * 2
            k = i * 3

            adCoords(j * 3) = oP(k)
            adCoords(j * 3 + 1) = oP(k + 1)
            adCoords(j * 3 + 2) = oP(k + 2)


            adCoords(j * 3 + 3) = oP(k) + oTan(k)
            adCoords(j * 3 + 4) = oP(k + 1) + oTan(k + 1)
            adCoords(j * 3 + 5) = oP(k + 2) + oTan(k + 2)
        Next



        Dim iID As Integer

        Dim oCoords As GraphicsCoordinateSet
        iID = iID + 1
        oCoords = oGraphicsData.CreateCoordinateSet(iID)
        Call oCoords.PutCoordinates(adCoords)

        'iID = iID + 1
        'Dim oIndexSet As GraphicsIndexSet
        'oIndexSet = oGraphicsData.CreateIndexSet(iID)

        'Dim oIndexCount As Long
        'oIndexCount = 1

        'For oIndexCount = 1 To lCount * 2 Step 2
        '    Call oIndexSet.Add(oIndexCount, oIndexCount)
        '    Call oIndexSet.Add(oIndexCount, oIndexCount + 1)

        'Next


        iID = iID + 1
        Dim oNode As GraphicsNode
        oNode = oClientGraphics.AddNode(iID)

        Dim oLines As LineGraphics
        oLines = oNode.AddLineGraphics

        'oMesh.CoordinateIndexSet = oIndexSet
        oLines.CoordinateSet = oCoords


        oApp.ActiveView.Update()
    End Sub
 
End Class
